package com.loafle.overflow.crawler;


import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.crawler.config.Config;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by root on 17. 4. 10.
 */
public abstract class Crawler {

    private Map<String,Config> configs;
    private String configPath;

    public Config getConfig(String id) throws Exception {
        return configs.get(id);
    }
    public void putConfig(String id,Config o) throws Exception {
        if (configs == null) {
            configs = new HashMap<String,Config>();
        }
        configs.put(id,o);
    }
    public String getConfigPath() {
        return configPath;
    }
    public void setConfigPath(String path) {
        if (path.endsWith("/")) {
            this.configPath = path;
        } else {
            this.configPath = path + "/";
        }
    }

    public Object add(String id) throws Exception {
        ObjectMapper mapper = new ObjectMapper();
        Config c = mapper.readValue(new File(this.getConfigPath() + id),Config.class);
        this.putConfig(id,c);
        return true;
    }

    public Object get(String id) throws Exception {
        return getInternal(getConfig(id));
    }



    public Object init(String config) throws Exception {
        this.setConfigPath(config);
        File dir = new File(config);
        for (File file : dir.listFiles()) {
            this.add(file.getName());
        }
        return true;
    }

    public Object remove(String id) throws Exception {
        this.configs.remove(id);
        return true;
    }

    public abstract  Object getInternal(Config c) throws Exception;


}
